]> git.proxmox.com Git - rustc.git/blob - src/ci/shared.sh
New upstream version 1.19.0+dfsg1
[rustc.git] / src / ci / shared.sh
1 #!/bin/false
2 # Copyright 2016 The Rust Project Developers. See the COPYRIGHT
3 # file at the top-level directory of this distribution and at
4 # http://rust-lang.org/COPYRIGHT.
5 #
6 # Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
7 # http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
8 # <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
9 # option. This file may not be copied, modified, or distributed
10 # except according to those terms.
11
12 # This file is intended to be sourced with `. shared.sh` or
13 # `source shared.sh`, hence the invalid shebang and not being
14 # marked as an executable file in git.
15
16 # See http://unix.stackexchange.com/questions/82598
17 function retry {
18 echo "Attempting with retry:" "$@"
19 local n=1
20 local max=5
21 while true; do
22 "$@" && break || {
23 if [[ $n -lt $max ]]; then
24 ((n++))
25 echo "Command failed. Attempt $n/$max:"
26 else
27 echo "The command has failed after $n attempts."
28 exit 1
29 fi
30 }
31 done
32 }
33
34 if ! declare -F travis_fold; then
35 if [ "${TRAVIS-false}" = 'true' ]; then
36 # This is a trimmed down copy of
37 # https://github.com/travis-ci/travis-build/blob/master/lib/travis/build/templates/header.sh
38 travis_fold() {
39 echo -en "travis_fold:$1:$2\r\033[0K"
40 }
41 travis_time_start() {
42 travis_timer_id=$(printf %08x $(( RANDOM * RANDOM )))
43 travis_start_time=$(travis_nanoseconds)
44 echo -en "travis_time:start:$travis_timer_id\r\033[0K"
45 }
46 travis_time_finish() {
47 travis_end_time=$(travis_nanoseconds)
48 local duration=$(($travis_end_time-$travis_start_time))
49 local msg="travis_time:end:$travis_timer_id"
50 echo -en "\n$msg:start=$travis_start_time,finish=$travis_end_time,duration=$duration\r\033[0K"
51 }
52 if [ $(uname) = 'Darwin' ]; then
53 travis_nanoseconds() {
54 date -u '+%s000000000'
55 }
56 else
57 travis_nanoseconds() {
58 date -u '+%s%N'
59 }
60 fi
61 else
62 travis_fold() { return 0; }
63 travis_time_start() { return 0; }
64 travis_time_finish() { return 0; }
65 fi
66 fi